routes/web.php
<?php

use App\Http\Controllers\Admin\AdminController;
use App\Http\Controllers\Admin\FacultyController;
use App\Http\Controllers\Admin\TeacherController as AdminTeacherController;
use App\Http\Controllers\Admin\UserController as AdminUserController;
use App\Http\Controllers\Teacher\TeacherController;
use App\Http\Controllers\User\UserController;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
 */

Route::get('/', function () {
    if (Auth::check()) {
        return redirect()->back()->with('status', 'you are already logged in');
    } else {
        return view('auth.login');
    }

});

//Middleware group
Route::middleware(['middleware' => 'PreventBackHistory'])->group(function () {
    Auth::routes();
});

// Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

//Admin
Route::group(['namespace' => 'Admin', 'prefix' => 'admin', 'as' => 'admin.', 'middleware' => ['isAdmin', 'auth', 'PreventBackHistory']], function () {
    Route::get('dashboard', [AdminController::class, 'index'])->name('dashboard');
    Route::get('profile', [AdminController::class, 'profile'])->name('profile');
    Route::get('settings', [AdminController::class, 'settings'])->name('settings');

    //Users CRUD -admin dashboard
    Route::get('/user/view', [AdminUserController::class, 'userView'])->name('userview');
    Route::get('/user/add', [AdminUserController::class, 'userAdd'])->name('useradd');
    Route::post('/user/store', [AdminUserController::class, 'userStore'])->name('userstore');
    Route::get('/user/edit/{id}', [AdminUserController::class, 'userEdit'])->name('useredit');
    Route::post('/user/update/{id}', [AdminUserController::class, 'userUpdate'])->name('userupdate');
    Route::get('/user/delete/{id}', [AdminUserController::class, 'userDelete'])->name('userdelete');

    //Teachers CRUD -admin-dashboard
    Route::get('/teacher/view', [AdminTeacherController::class, 'teacherView'])->name('teacherview');
    Route::get('/teacher/add', [AdminTeacherController::class, 'teacherAdd'])->name('teacheradd');
    Route::post('/teacher/store', [AdminTeacherController::class, 'teacherStore'])->name('teacherstore');
    Route::get('/teacher/edit/{id}', [AdminTeacherController::class, 'teacherEdit'])->name('teacheredit');
    Route::post('/teacher/update/{id}', [AdminTeacherController::class, 'teacherUpdate'])->name('teacherupdate');
    Route::get('/teacher/delete/{id}', [AdminTeacherController::class, 'teacherDelete'])->name('teacherdelete');

    //Faculty CRUD -admin-dashboard
    Route::get('/faculty/view', [FacultyController::class, 'facultyView'])->name('facultyview');
    Route::get('/faculty/add', [FacultyController::class, 'facultyAdd'])->name('facultyadd');
    Route::post('/faculty/store', [FacultyController::class, 'facultyStore'])->name('facultystore');
    Route::get('/faculty/edit/{id}', [FacultyController::class, 'facultyEdit'])->name('facultyedit');
    Route::post('/faculty/update/{id}', [FacultyController::class, 'facultyUpdate'])->name('facultyupdate');
    Route::get('/faculty/delete/{id}', [FacultyController::class, 'facultyDelete'])->name('facultydelete');
});

//Teacher
Route::group(['namespace' => 'Teacher', 'prefix' => 'teacher', 'as' => 'teacher.', 'middleware' => ['isTeacher', 'auth', 'PreventBackHistory']], function () {
    //profile
    Route::get('profile', [TeacherController::class, 'profile'])->name('profile');
    Route::get('/profile/edit', [TeacherController::class, 'profileEdit'])->name('editprofile');
    Route::post('/profile/store', [TeacherController::class, 'profileStore'])->name('profilestore');
    //settings
    Route::get('settings', [TeacherController::class, 'settings'])->name('settings');
    Route::post('settings/changepassword', [TeacherController::class, 'changePassword'])->name('profilesettings');
});

//User
Route::group(['namespace' => 'User', 'prefix' => 'user', 'as' => 'user.', 'middleware' => ['isUser', 'auth', 'PreventBackHistory']], function () {
    //profile
    Route::get('profile', [UserController::class, 'profile'])->name('profile');
    Route::get('/profile/edit', [UserController::class, 'profileEdit'])->name('editprofile');
    Route::post('/profile/store', [UserController::class, 'profileStore'])->name('profilestore');
    //settings
    Route::get('settings', [UserController::class, 'settings'])->name('settings');
    Route::post('settings/changepassword', [UserController::class, 'changePassword'])->name('profilesettings');

});

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var string[]
     */
    protected $fillable = [
        'name',
        'email',
        'role',
        'faculty_id',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function faculty()
    {

        return $this->belongsTo(Faculty::class);

    }
}

app/Http/Controllers/Admin/UserController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;

class UserController extends Controller
{
    public function userView()
    {
        // $allData = User::all();
        $data['allData'] = User::all()->where('role', '=', 3); // fetching data from multiple models
        return view('backend.user.view_user', $data);
    }

    public function userAdd()
    {
        return view('backend.user.add_user');
    }

    public function userStore(Request $request)
    {
        $request->validate([
            'name' => 'required',
            'email' => 'required|unique:users',
            'password' => 'required',

        ]);
        $data = new User();
        $data->name = $request->name;
        $data->email = $request->email;
        $data->role = 3;
        $data->password = Hash::make($request->password);

        if ($data->save()) {
            return redirect()->route('admin.userview')->with('success', 'Student is registered');
        }
        return redirect()->back()->with('error', "could not register the user");
    }

    public function userEdit($id)
    {
        $editData = User::find($id);
        return view('backend.user.edit_user', compact('editData'));
    }

    public function userUpdate(Request $request, $id)
    {
        $data = User::find($id);
        $data->name = $request->name;
        $data->email = $request->email;
        $data->role = 3;
        $data->password = Hash::make($request->password);

        if ($data->update()) {
            return redirect()->route('admin.userview')->with('success', 'Student info Updated');
        }
        return redirect()->back()->with('error', "could not update the user data");
    }

    public function userDelete($id)
    {
        $user = User::find($id);
        $user->delete();
        return redirect()->route('admin.userview')->with('success', 'User Deleted Successfully');
    }
}

app/Http/Controllers/Api/UserController.php
<?php

namespace App\Http\Controllers\Api;

use App\Http\Controllers\Controller;
use App\Models\User;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Str;

class UserController extends Controller
{

    public function register(Request $request)
    {
        $request->validate([
            'name' => 'required|string',
            'email' => 'required|string|unique:users,email',
            'role' => 'required',
            'faculty_id' => 'required',
            'password' => 'required|string|confirmed',
        ]);
        $user = new User();
        $user->name = $request->input('name');
        $user->email = $request->input('email');
        $user->role = $request->input('role');
        $user->faculty_id = $request->input('faculty_id');
        $user->email_verified_at = Carbon::now();
        $user->password = Hash::make($request->input('password'));
        $user->remember_token = Str::random(10);
        if ($user->save()) {
            $token = $user->createToken('scl-mgmt-token')->plainTextToken;

            $response = [
                'user' => $user,
                'token' => $token,
            ];

            return response($response, 201);
        }
        return ["error" => "user cannot be registered"];

    }

    public function login(Request $request)
    {
        $cred = $request->validate([
            'email' => 'required|exists:users,email',
            'password' => 'required',
        ]);
        if (Auth::attempt(['email' => $cred['email'], 'password' => $cred['password']])) {
            $token = Auth::user()->createToken('scl-mgmt-token')->plainTextToken;
            $response = [
                'message' => 'You are logged in',
                'token' => $token,
            ];
            return response($response, 200);
        }

        return ["error" => "could not login"];
    }

    public function updateinfo(Request $request)
    {
        $request->validate([
            'name' => 'required',
            'email' => 'required',
            'faculty_id' => 'required',
        ]);
        $data = User::find(Auth::user()->id);
        $data->name = $request->input('name');
        $data->email = $request->input('email');
        $data->faculty_id = $request->input('faculty_id');
        if ($data->save()) {
            $response = [
                'message' => 'your info updated',

            ];
            return response($response, 200);
        }
        return ["error" => "could not update the user data"];

    }

    public function logout()
    {
        Auth::user()->tokens()->delete();

        return [
            'message' => 'logged out',
        ];
    }
}

app/Http/Controllers/User/UserController.php
<?php

namespace App\Http\Controllers\User;

use App\Http\Controllers\Controller;
use App\Models\Faculty;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;

class UserController extends Controller
{
    public function __construct()
    {
        $this->middleware('auth');
    }
    public function index()
    {

        return view('dashboard.users.index');
    }

    public function profile()
    {
        return view('dashboard.users.profile');
    }

    public function profileEdit()
    {
        $id = Auth::user()->id;
        $editData = User::find($id);
        $faculty = Faculty::all();
        return view('dashboard.users.edit_profile', compact('editData', 'faculty'));
    }
    public function profileStore(Request $request)
    {
        $data = User::find(Auth::user()->id);

        $data->name = $request->name;
        $data->email = $request->email;
        $data->faculty_id = $request->faculty_id;
        if ($data->save()) {
            return redirect()->route('user.editprofile')->with('success', 'profile updated successfully');
        }
        return redirect()->route('user.editprofile')->with('error', 'something weent wrong, could  not update your profile');

    }

    public function settings()
    {
        return view('dashboard.users.settings');
    }

    public function changePassword(Request $request)
    {
        $request->validate([
            'current_password' => 'required',
            'password' => 'required|string|min:6|confirmed',
            'password_confirmation' => 'required',
        ]);

        $data = User::find(Auth::user()->id);

        if (!Hash::check($request->current_password, $data->password)) {
            return back()->with('error', 'Current password does not match!');
        }

        $data->password = Hash::make($request->password);
        $data->save();

        return back()->with('success', 'Password successfully changed!');

    }
}

resources/views/backend/user/add_user.blade.php
@extends('dashboard.admins.admin_master')
@section('admin-content')
<div class="content-wrapper">
    <div class="container-full">


        <section class="content">

            <!-- Basic Forms -->
            <div class="box">
                <div class="box-header with-border">
                    <h4 class="box-title">Add Student</h4>

                </div>
                <!-- /.box-header -->
                <div class="box-body">
                    <div class="row">
                        <div class="col">
                            <form method="POST" action="{{ route('admin.userstore') }}">
                                @csrf
                                <div class="row">
                                    <div class="col-12">
                                        <div class="form-group">
                                            <h5>Name<span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="text" name="name" id="name" class="form-control"
                                                    data-validation-required-message="This field is required">
                                                <div class="help-block"></div>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <h5>Email Field <span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="email" name="email" id="email" class="form-control"
                                                    data-validation-required-message="This field is required">
                                                <div class="help-block"></div>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <h5>Password Input Field <span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="password" name="password" class="form-control"
                                                    data-validation-required-message="This field is required">
                                                <div class="help-block"></div>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <h5>Repeat Password Input Field <span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="password" name="password_confirmation"
                                                    id="password-confirm" data-validation-match-match="password"
                                                    class="form-control">
                                                <div class="help-block"></div>
                                            </div>
                                        </div>


                                        {{-- <div class="form-group">
                                            <h5>Student <span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="hidden" name="role" value="3">
                                                <div class="help-block"></div>
                                            </div>
                                        </div> --}}
                                        <div class="text-xs-right">
                                            <input type="submit" class="btn btn--rounded btn-info mb-5"
                                                value="Add Student">
                                        </div>
                            </form>

                        </div>
                        <!-- /.col -->
                    </div>
                    <!-- /.row -->
                </div>
                <!-- /.box-body -->
            </div>
            <!-- /.box -->

        </section>


    </div>
</div>
@endsection

resources/views/backend/user/edit_user.blade.php
@extends('dashboard.admins.admin_master')
@section('admin-content')
<div class="content-wrapper">
    <div class="container-full">


        <section class="content">

            <!-- Basic Forms -->
            <div class="box">
                <div class="box-header with-border">
                    <h4 class="box-title">Update Student Info</h4>

                </div>
                <!-- /.box-header -->
                <div class="box-body">
                    <div class="row">
                        <div class="col">
                            <form method="POST" action="{{ route('admin.userupdate',$editData->id) }}">
                                @csrf
                                <div class="row">
                                    <div class="col-12">
                                        <div class="form-group">
                                            <h5>Name<span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="text" name="name" id="name" class="form-control"
                                                    data-validation-required-message="This field is required"
                                                    value="{{ $editData->name }}">
                                                <div class="help-block"></div>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <h5>Email Field <span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="email" name="email" id="email" class="form-control"
                                                    data-validation-required-message="This field is required"
                                                    value={{ $editData->email }}>
                                                <div class="help-block"></div>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <h5>Password Input Field <span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="password" name="password" class="form-control"
                                                    data-validation-required-message="This field is required">
                                                <div class="help-block"></div>
                                            </div>
                                        </div>

                                        <div class="form-group">
                                            <h5>Repeat Password Input Field <span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="password" name="password_confirmation"
                                                    id="password-confirm" data-validation-match-match="password"
                                                    class="form-control">
                                                <div class="help-block"></div>
                                            </div>
                                        </div>


                                        {{-- <div class="form-group">
                                            <h5>Student <span class="text-danger">*</span></h5>
                                            <div class="controls">
                                                <input type="hidden" name="role" value="3">
                                                <div class="help-block"></div>
                                            </div>
                                        </div> --}}
                                        <div class="text-xs-right">
                                            <input type="submit" class="btn btn--rounded btn-info mb-5" value="update">
                                        </div>
                            </form>

                        </div>
                        <!-- /.col -->
                    </div>
                    <!-- /.row -->
                </div>
                <!-- /.box-body -->
            </div>
            <!-- /.box -->

        </section>


    </div>
</div>
@endsection

resources/views/backend/user/view_user.blade.php
@extends('dashboard.admins.admin_master')
@section('admin-content')
<div class="content-wrapper">
    <div class="container-full">
        <!-- Main content -->
        <section class="content">
            <div class="row">

                <div class="col-12">

                    <div class="box">
                        <div class="box-header with-border">
                            <h3 class="box-title">Users Management</h3>
                            @if (session('success'))
                            <div class="alert alert-success" role="alert">
                                {{ session('success') }}
                            </div>
                            @endif
                            @if (session('error'))
                            <div class="alert alert-danger" role="alert">
                                {{ session('error') }}
                            </div>
                            @endif
                            <a href="{{ route('admin.useradd') }}" style="float: right"
                                class="btn btn-rounded btn-success mb-5">Add User</a>
                        </div>
                        <!-- /.box-header -->
                        <div class="box-body">
                            <div class="table-responsive">
                                <table id="example1" class="table table-bordered table-striped">
                                    <thead>
                                        <tr>
                                            <th>SL</th>
                                            <th>Name</th>
                                            <th>Email</th>
                                            <th>Role</th>
                                            <th>Action</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        @foreach ($allData as $key => $user )
                                        <tr>
                                            <td>{{ $key+1 }}</td>
                                            <td>{{ $user->name }}</td>
                                            <td>{{ $user->email }}</td>
                                            <td>{{ $user->role }}</td>
                                            <td>
                                                <a href="{{ route('admin.useredit',$user->id) }}"
                                                    class="btn btn-info">Edit</a>
                                                <a href="{{ route('admin.userdelete',$user->id) }}"
                                                    class="btn btn-danger">Delete</a>
                                            </td>
                                        </tr>
                                        @endforeach
                                    </tbody>
                                    <tfoot>
                                        <tr>
                                            <th>SL</th>
                                            <th>Name</th>
                                            <th>Email</th>
                                            <th>Role</th>
                                            <th>Action</th>
                                        </tr>
                                    </tfoot>
                                </table>
                            </div>
                        </div>
                        <!-- /.box-body -->
                    </div>
                    <!-- /.box -->
                </div>
                <!-- /.col -->
            </div>
            <!-- /.row -->
        </section>
        <!-- /.content -->

    </div>
</div>
@endsection